;;;
;;;  language.scm: grammar and everything for the BE's language
;;;
;;;
;;;  Copyright (C) 2001 Samuel Hocevar
;;;  $Id: language.scm,v 1.1 2001/11/28 00:55:02 sam Exp $
;;; 
;;;  Authors: Samuel Hocevar <sam@zoy.org>
;;; 
;;;  This program is free software; you can redistribute it and/or modify
;;;  it under the terms of the GNU General Public License as published by
;;;  the Free Software Foundation; either version 2 of the License, or
;;;  (at your option) any later version.
;;;  
;;;  This program is distributed in the hope that it will be useful,
;;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;  GNU General Public License for more details.
;;; 
;;;  You should have received a copy of the GNU General Public License
;;;  along with this program; if not, write to the Free Software
;;;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.


;;;
;;;  The grammar
;;;

(define *grammar*
  '((prog        (inst_affect (* (";" inst_affect)) $))
    (inst_affect (var ":=" expr))
    (var         (ident index))
    (index       ("[" indices "]")
                 ())
    (ident       ("a") ("b") ("c") ("d") ("e") ("f") ("g") ("h") ("i")
                 ("j") ("k") ("l") ("m") ("n") ("o") ("p") ("q") ("r")
                 ("s") ("t") ("u") ("v") ("w") ("x") ("y") ("z"))
    (indices     (expr (* ("," expr))))
    (expr        (expr_simple)
                 ("SI" expr oper_comp expr "ALORS" expr "SINON" expr))
    (oper_comp   ("#") ("=") ("<") (">") ("<=") (">="))
    (expr_simple (tete_expr (* (oper_add terme))))
    (tete_expr   (terme)
                 ("+" terme)
                 ("-" terme))
    (oper_add    ("+") ("-"))
    (terme       (fact (* (oper_mul fact))))
    (oper_mul    ("*") ("/"))
    (fact        ("(" expr ")")
                 (var))))

;;;
;;;  The other stuff
;;;

(load "lang/be/optim.scm")
(load "lang/be/codegen.scm")

